/* chess-state.c generated by valac 0.46.1, the Vala compiler
 * generated from chess-state.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2010-2014 Robert Ancell
 * Copyright (C) 2015-2016 Sahil Sareen
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>

typedef enum  {
	CHECK_STATE_NONE,
	CHECK_STATE_CHECK,
	CHECK_STATE_CHECKMATE
} CheckState;

#define TYPE_CHECK_STATE (check_state_get_type ())

#define TYPE_CHESS_STATE (chess_state_get_type ())
#define CHESS_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_STATE, ChessState))
#define CHESS_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_STATE, ChessStateClass))
#define IS_CHESS_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_STATE))
#define IS_CHESS_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_STATE))
#define CHESS_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_STATE, ChessStateClass))

typedef struct _ChessState ChessState;
typedef struct _ChessStateClass ChessStateClass;
typedef struct _ChessStatePrivate ChessStatePrivate;

#define TYPE_CHESS_PLAYER (chess_player_get_type ())
#define CHESS_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_PLAYER, ChessPlayer))
#define CHESS_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_PLAYER, ChessPlayerClass))
#define IS_CHESS_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_PLAYER))
#define IS_CHESS_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_PLAYER))
#define CHESS_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_PLAYER, ChessPlayerClass))

typedef struct _ChessPlayer ChessPlayer;
typedef struct _ChessPlayerClass ChessPlayerClass;

#define TYPE_CHESS_PIECE (chess_piece_get_type ())
#define CHESS_PIECE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_PIECE, ChessPiece))
#define CHESS_PIECE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_PIECE, ChessPieceClass))
#define IS_CHESS_PIECE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_PIECE))
#define IS_CHESS_PIECE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_PIECE))
#define CHESS_PIECE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_PIECE, ChessPieceClass))

typedef struct _ChessPiece ChessPiece;
typedef struct _ChessPieceClass ChessPieceClass;

#define TYPE_CHESS_MOVE (chess_move_get_type ())
#define CHESS_MOVE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_MOVE, ChessMove))
#define CHESS_MOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_MOVE, ChessMoveClass))
#define IS_CHESS_MOVE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_MOVE))
#define IS_CHESS_MOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_MOVE))
#define CHESS_MOVE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_MOVE, ChessMoveClass))

typedef struct _ChessMove ChessMove;
typedef struct _ChessMoveClass ChessMoveClass;
enum  {
	CHESS_STATE_0_PROPERTY,
	CHESS_STATE_OPPONENT_PROPERTY,
	CHESS_STATE_NUM_PROPERTIES
};
static GParamSpec* chess_state_properties[CHESS_STATE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef enum  {
	COLOR_WHITE,
	COLOR_BLACK
} Color;

#define TYPE_COLOR (color_get_type ())
typedef enum  {
	PIECE_TYPE_PAWN,
	PIECE_TYPE_ROOK,
	PIECE_TYPE_KNIGHT,
	PIECE_TYPE_BISHOP,
	PIECE_TYPE_QUEEN,
	PIECE_TYPE_KING
} PieceType;

#define TYPE_PIECE_TYPE (piece_type_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ChessPlayerPrivate ChessPlayerPrivate;
typedef struct _ChessPiecePrivate ChessPiecePrivate;
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _ChessMovePrivate ChessMovePrivate;
typedef enum  {
	CHESS_RULE_UNKNOWN,
	CHESS_RULE_CHECKMATE,
	CHESS_RULE_STALEMATE,
	CHESS_RULE_FIFTY_MOVES,
	CHESS_RULE_SEVENTY_FIVE_MOVES,
	CHESS_RULE_TIMEOUT,
	CHESS_RULE_THREE_FOLD_REPETITION,
	CHESS_RULE_FIVE_FOLD_REPETITION,
	CHESS_RULE_INSUFFICIENT_MATERIAL,
	CHESS_RULE_RESIGN,
	CHESS_RULE_ABANDONMENT,
	CHESS_RULE_DEATH,
	CHESS_RULE_BUG
} ChessRule;

#define TYPE_CHESS_RULE (chess_rule_get_type ())
typedef enum  {
	CHESS_RESULT_IN_PROGRESS,
	CHESS_RESULT_WHITE_WON,
	CHESS_RESULT_BLACK_WON,
	CHESS_RESULT_DRAW,
	CHESS_RESULT_BUG
} ChessResult;

#define TYPE_CHESS_RESULT (chess_result_get_type ())

struct _ChessState {
	GObject parent_instance;
	ChessStatePrivate * priv;
	gint number;
	ChessPlayer* players[2];
	ChessPlayer* current_player;
	gboolean can_castle_kingside[2];
	gboolean can_castle_queenside[2];
	gint en_passant_index;
	CheckState check_state;
	gint halfmove_clock;
	ChessPiece* board[64];
	ChessMove* last_move;
};

struct _ChessStateClass {
	GObjectClass parent_class;
};

struct _ChessStatePrivate {
	gint64 piece_masks[2];
};

struct _ChessPlayer {
	GObject parent_instance;
	ChessPlayerPrivate * priv;
	Color color;
};

struct _ChessPlayerClass {
	GObjectClass parent_class;
};

struct _ChessPiece {
	GObject parent_instance;
	ChessPiecePrivate * priv;
	ChessPlayer* player;
	PieceType type;
};

struct _ChessPieceClass {
	GObjectClass parent_class;
};

struct _ChessMove {
	GObject parent_instance;
	ChessMovePrivate * priv;
	gint number;
	ChessPiece* piece;
	ChessPiece* promotion_piece;
	ChessPiece* castling_rook;
	ChessPiece* victim;
	gint r0;
	gint f0;
	gint r1;
	gint f1;
	gboolean ambiguous_rank;
	gboolean ambiguous_file;
	gboolean en_passant;
	CheckState check_state;
};

struct _ChessMoveClass {
	GObjectClass parent_class;
};

static gint ChessState_private_offset;
static gpointer chess_state_parent_class = NULL;

GType check_state_get_type (void) G_GNUC_CONST;
GType chess_state_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ChessState, g_object_unref)
GType chess_player_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ChessPlayer, g_object_unref)
GType chess_piece_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ChessPiece, g_object_unref)
GType chess_move_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ChessMove, g_object_unref)
static ChessState* chess_state_new_empty (void);
static ChessState* chess_state_construct_empty (GType object_type);
ChessState* chess_state_new (const gchar* fen);
ChessState* chess_state_construct (GType object_type,
                                   const gchar* fen);
GType color_get_type (void) G_GNUC_CONST;
ChessPlayer* chess_player_new (Color color);
ChessPlayer* chess_player_construct (GType object_type,
                                     Color color);
GType piece_type_get_type (void) G_GNUC_CONST;
static gboolean chess_state_decode_piece_type (ChessState* self,
                                        gunichar c,
                                        PieceType* type);
gint chess_state_get_index (ChessState* self,
                            gint rank,
                            gint file);
ChessPiece* chess_piece_new (ChessPlayer* player,
                             PieceType type);
ChessPiece* chess_piece_construct (GType object_type,
                                   ChessPlayer* player,
                                   PieceType type);
static CheckState chess_state_get_check_state (ChessState* self,
                                        ChessPlayer* player);
ChessState* chess_state_copy (ChessState* self);
ChessMove* chess_move_copy (ChessMove* self);
gboolean chess_state_equals (ChessState* self,
                             ChessState* state);
gchar* chess_state_get_fen (ChessState* self);
gunichar chess_piece_get_symbol (ChessPiece* self);
gint chess_state_get_file (ChessState* self,
                           gint index);
gint chess_state_get_rank (ChessState* self,
                           gint index);
gboolean chess_state_move (ChessState* self,
                           const gchar* move,
                           gboolean apply);
static gboolean chess_state_decode_move (ChessState* self,
                                  ChessPlayer* player,
                                  const gchar* move,
                                  gint* r0,
                                  gint* f0,
                                  gint* r1,
                                  gint* f1,
                                  PieceType* promotion_type);
gboolean chess_state_move_with_coords (ChessState* self,
                                       ChessPlayer* player,
                                       gint r0,
                                       gint f0,
                                       gint r1,
                                       gint f1,
                                       PieceType promotion_type,
                                       gboolean apply,
                                       gboolean test_check);
Color chess_piece_get_color (ChessPiece* self);
gboolean chess_state_is_in_check (ChessState* self,
                                  ChessPlayer* player);
ChessMove* chess_move_new (void);
ChessMove* chess_move_construct (GType object_type);
GType chess_rule_get_type (void) G_GNUC_CONST;
GType chess_result_get_type (void) G_GNUC_CONST;
ChessResult chess_state_get_result (ChessState* self,
                                    ChessRule* rule);
static gboolean chess_state_can_move (ChessState* self,
                               ChessPlayer* player);
gboolean chess_state_have_sufficient_material (ChessState* self);
static gboolean chess_state_is_in_checkmate (ChessState* self,
                                      ChessPlayer* player);
ChessPlayer* chess_state_get_opponent (ChessState* self);
static void chess_state_finalize (GObject * obj);
static void _vala_chess_state_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

extern const gint64 BIT_BOARD_set_location_masks[64];
extern const gint64 BIT_BOARD_move_masks[768];
extern const gint64 BIT_BOARD_over_masks[4096];
extern const gint64 BIT_BOARD_clear_location_masks[64];

GType
check_state_get_type (void)
{
	static volatile gsize check_state_type_id__volatile = 0;
	if (g_once_init_enter (&check_state_type_id__volatile)) {
		static const GEnumValue values[] = {{CHECK_STATE_NONE, "CHECK_STATE_NONE", "none"}, {CHECK_STATE_CHECK, "CHECK_STATE_CHECK", "check"}, {CHECK_STATE_CHECKMATE, "CHECK_STATE_CHECKMATE", "checkmate"}, {0, NULL, NULL}};
		GType check_state_type_id;
		check_state_type_id = g_enum_register_static ("CheckState", values);
		g_once_init_leave (&check_state_type_id__volatile, check_state_type_id);
	}
	return check_state_type_id__volatile;
}

static inline gpointer
chess_state_get_instance_private (ChessState* self)
{
	return G_STRUCT_MEMBER_P (self, ChessState_private_offset);
}

static ChessState*
chess_state_construct_empty (GType object_type)
{
	ChessState * self = NULL;
	self = (ChessState*) g_object_new (object_type, NULL);
	return self;
}

static ChessState*
chess_state_new_empty (void)
{
	return chess_state_construct_empty (TYPE_CHESS_STATE);
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result = '\0';
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = ((gchar*) self)[index];
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

ChessState*
chess_state_construct (GType object_type,
                       const gchar* fen)
{
	ChessState * self = NULL;
	ChessPlayer* _tmp0_;
	ChessPlayer* _tmp1_;
	gchar** fields = NULL;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gint fields_length1;
	gint _fields_size_;
	gchar** ranks = NULL;
	gchar** _tmp6_;
	gint _tmp6__length1;
	const gchar* _tmp7_;
	gchar** _tmp8_;
	gchar** _tmp9_;
	gint ranks_length1;
	gint _ranks_size_;
	gchar** _tmp34_;
	gint _tmp34__length1;
	const gchar* _tmp35_;
	gchar** _tmp42_;
	gint _tmp42__length1;
	const gchar* _tmp43_;
	gchar** _tmp52_;
	gint _tmp52__length1;
	const gchar* _tmp53_;
	gchar** _tmp58_;
	gint _tmp58__length1;
	const gchar* _tmp59_;
	gchar** _tmp60_;
	gint _tmp60__length1;
	const gchar* _tmp61_;
	ChessPlayer* _tmp62_;
	Color _tmp63_;
	ChessPlayer* _tmp65_;
	g_return_val_if_fail (fen != NULL, NULL);
	self = (ChessState*) g_object_new (object_type, NULL);
	_tmp0_ = chess_player_new (COLOR_WHITE);
	_g_object_unref0 (self->players[COLOR_WHITE]);
	self->players[COLOR_WHITE] = _tmp0_;
	_tmp1_ = chess_player_new (COLOR_BLACK);
	_g_object_unref0 (self->players[COLOR_BLACK]);
	self->players[COLOR_BLACK] = _tmp1_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				if (!_tmp2_) {
					gint _tmp3_;
					_tmp3_ = i;
					i = _tmp3_ + 1;
				}
				_tmp2_ = FALSE;
				if (!(i < 64)) {
					break;
				}
				_g_object_unref0 (self->board[i]);
				self->board[i] = NULL;
			}
		}
	}
	_tmp5_ = _tmp4_ = g_strsplit (fen, " ", 0);
	fields = _tmp5_;
	fields_length1 = _vala_array_length (_tmp4_);
	_fields_size_ = fields_length1;
	_tmp6_ = fields;
	_tmp6__length1 = fields_length1;
	_tmp7_ = _tmp6_[0];
	_tmp9_ = _tmp8_ = g_strsplit (_tmp7_, "/", 0);
	ranks = _tmp9_;
	ranks_length1 = _vala_array_length (_tmp8_);
	_ranks_size_ = ranks_length1;
	{
		gint rank = 0;
		rank = 0;
		{
			gboolean _tmp10_ = FALSE;
			_tmp10_ = TRUE;
			while (TRUE) {
				gchar* rank_string = NULL;
				gchar** _tmp12_;
				gint _tmp12__length1;
				const gchar* _tmp13_;
				gchar* _tmp14_;
				if (!_tmp10_) {
					gint _tmp11_;
					_tmp11_ = rank;
					rank = _tmp11_ + 1;
				}
				_tmp10_ = FALSE;
				if (!(rank < 8)) {
					break;
				}
				_tmp12_ = ranks;
				_tmp12__length1 = ranks_length1;
				_tmp13_ = _tmp12_[7 - rank];
				_tmp14_ = g_strdup (_tmp13_);
				rank_string = _tmp14_;
				{
					gint file = 0;
					gint offset = 0;
					file = 0;
					offset = 0;
					{
						gboolean _tmp15_ = FALSE;
						_tmp15_ = TRUE;
						while (TRUE) {
							gboolean _tmp17_ = FALSE;
							gchar c = '\0';
							const gchar* _tmp21_;
							gboolean _tmp22_ = FALSE;
							PieceType type = 0;
							Color _tmp23_ = 0;
							Color color = 0;
							PieceType _tmp24_ = 0;
							gint index = 0;
							ChessPiece* piece = NULL;
							Color _tmp25_;
							ChessPlayer* _tmp26_;
							PieceType _tmp27_;
							ChessPiece* _tmp28_;
							ChessPiece* _tmp29_;
							ChessPiece* _tmp30_;
							gint64 mask = 0LL;
							gint64 _tmp31_;
							Color _tmp32_;
							gint _tmp33_;
							if (!_tmp15_) {
								gint _tmp16_;
								_tmp16_ = offset;
								offset = _tmp16_ + 1;
							}
							_tmp15_ = FALSE;
							if (file < 8) {
								const gchar* _tmp18_;
								gint _tmp19_;
								gint _tmp20_;
								_tmp18_ = rank_string;
								_tmp19_ = strlen (_tmp18_);
								_tmp20_ = _tmp19_;
								_tmp17_ = offset < _tmp20_;
							} else {
								_tmp17_ = FALSE;
							}
							if (!_tmp17_) {
								break;
							}
							_tmp21_ = rank_string;
							c = string_get (_tmp21_, (glong) offset);
							if (c >= '1') {
								_tmp22_ = c <= '8';
							} else {
								_tmp22_ = FALSE;
							}
							if (_tmp22_) {
								file += (gint) (c - '0');
								continue;
							}
							if (g_ascii_isupper (c)) {
								_tmp23_ = COLOR_WHITE;
							} else {
								_tmp23_ = COLOR_BLACK;
							}
							color = _tmp23_;
							chess_state_decode_piece_type (self, (gunichar) g_ascii_toupper (c), &_tmp24_);
							type = _tmp24_;
							index = chess_state_get_index (self, rank, file);
							_tmp25_ = color;
							_tmp26_ = self->players[_tmp25_];
							_tmp27_ = type;
							_tmp28_ = chess_piece_new (_tmp26_, _tmp27_);
							piece = _tmp28_;
							_tmp29_ = piece;
							_tmp30_ = _g_object_ref0 (_tmp29_);
							_g_object_unref0 (self->board[index]);
							self->board[index] = _tmp30_;
							_tmp31_ = BIT_BOARD_set_location_masks[index];
							mask = _tmp31_;
							_tmp32_ = color;
							self->priv->piece_masks[_tmp32_] |= mask;
							_tmp33_ = file;
							file = _tmp33_ + 1;
							_g_object_unref0 (piece);
						}
					}
				}
				_g_free0 (rank_string);
			}
		}
	}
	_tmp34_ = fields;
	_tmp34__length1 = fields_length1;
	_tmp35_ = _tmp34_[1];
	if (g_strcmp0 (_tmp35_, "w") == 0) {
		ChessPlayer* _tmp36_;
		ChessPlayer* _tmp37_;
		_tmp36_ = self->players[COLOR_WHITE];
		_tmp37_ = _g_object_ref0 (_tmp36_);
		_g_object_unref0 (self->current_player);
		self->current_player = _tmp37_;
	} else {
		gchar** _tmp38_;
		gint _tmp38__length1;
		const gchar* _tmp39_;
		_tmp38_ = fields;
		_tmp38__length1 = fields_length1;
		_tmp39_ = _tmp38_[1];
		if (g_strcmp0 (_tmp39_, "b") == 0) {
			ChessPlayer* _tmp40_;
			ChessPlayer* _tmp41_;
			_tmp40_ = self->players[COLOR_BLACK];
			_tmp41_ = _g_object_ref0 (_tmp40_);
			_g_object_unref0 (self->current_player);
			self->current_player = _tmp41_;
		}
	}
	_tmp42_ = fields;
	_tmp42__length1 = fields_length1;
	_tmp43_ = _tmp42_[2];
	if (g_strcmp0 (_tmp43_, "-") != 0) {
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp44_ = FALSE;
				_tmp44_ = TRUE;
				while (TRUE) {
					gchar** _tmp46_;
					gint _tmp46__length1;
					const gchar* _tmp47_;
					gint _tmp48_;
					gint _tmp49_;
					gchar c = '\0';
					gchar** _tmp50_;
					gint _tmp50__length1;
					const gchar* _tmp51_;
					if (!_tmp44_) {
						gint _tmp45_;
						_tmp45_ = i;
						i = _tmp45_ + 1;
					}
					_tmp44_ = FALSE;
					_tmp46_ = fields;
					_tmp46__length1 = fields_length1;
					_tmp47_ = _tmp46_[2];
					_tmp48_ = strlen (_tmp47_);
					_tmp49_ = _tmp48_;
					if (!(i < _tmp49_)) {
						break;
					}
					_tmp50_ = fields;
					_tmp50__length1 = fields_length1;
					_tmp51_ = _tmp50_[2];
					c = string_get (_tmp51_, (glong) i);
					if (c == 'K') {
						self->can_castle_kingside[COLOR_WHITE] = TRUE;
					} else {
						if (c == 'Q') {
							self->can_castle_queenside[COLOR_WHITE] = TRUE;
						} else {
							if (c == 'k') {
								self->can_castle_kingside[COLOR_BLACK] = TRUE;
							} else {
								if (c == 'q') {
									self->can_castle_queenside[COLOR_BLACK] = TRUE;
								}
							}
						}
					}
				}
			}
		}
	}
	_tmp52_ = fields;
	_tmp52__length1 = fields_length1;
	_tmp53_ = _tmp52_[3];
	if (g_strcmp0 (_tmp53_, "-") != 0) {
		gchar** _tmp54_;
		gint _tmp54__length1;
		const gchar* _tmp55_;
		gchar** _tmp56_;
		gint _tmp56__length1;
		const gchar* _tmp57_;
		_tmp54_ = fields;
		_tmp54__length1 = fields_length1;
		_tmp55_ = _tmp54_[3];
		_tmp56_ = fields;
		_tmp56__length1 = fields_length1;
		_tmp57_ = _tmp56_[3];
		self->en_passant_index = chess_state_get_index (self, (gint) (string_get (_tmp55_, (glong) 1) - '1'), (gint) (string_get (_tmp57_, (glong) 0) - 'a'));
	}
	_tmp58_ = fields;
	_tmp58__length1 = fields_length1;
	_tmp59_ = _tmp58_[4];
	self->halfmove_clock = atoi (_tmp59_);
	_tmp60_ = fields;
	_tmp60__length1 = fields_length1;
	_tmp61_ = _tmp60_[5];
	self->number = (atoi (_tmp61_) - 1) * 2;
	_tmp62_ = self->current_player;
	_tmp63_ = _tmp62_->color;
	if (_tmp63_ == COLOR_BLACK) {
		gint _tmp64_;
		_tmp64_ = self->number;
		self->number = _tmp64_ + 1;
	}
	_tmp65_ = self->current_player;
	self->check_state = chess_state_get_check_state (self, _tmp65_);
	ranks = (_vala_array_free (ranks, ranks_length1, (GDestroyNotify) g_free), NULL);
	fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
	return self;
}

ChessState*
chess_state_new (const gchar* fen)
{
	return chess_state_construct (TYPE_CHESS_STATE, fen);
}

ChessState*
chess_state_copy (ChessState* self)
{
	ChessState* state = NULL;
	ChessState* _tmp0_;
	ChessState* _tmp1_;
	ChessState* _tmp2_;
	ChessPlayer* _tmp3_;
	ChessPlayer* _tmp4_;
	ChessState* _tmp5_;
	ChessPlayer* _tmp6_;
	ChessPlayer* _tmp7_;
	ChessState* _tmp8_;
	ChessPlayer* _tmp9_;
	ChessPlayer* _tmp10_;
	ChessState* _tmp11_;
	gboolean _tmp12_;
	ChessState* _tmp13_;
	gboolean _tmp14_;
	ChessState* _tmp15_;
	gboolean _tmp16_;
	ChessState* _tmp17_;
	gboolean _tmp18_;
	ChessState* _tmp19_;
	ChessState* _tmp20_;
	CheckState _tmp21_;
	ChessMove* _tmp22_;
	ChessState* _tmp31_;
	gint64 _tmp32_;
	ChessState* _tmp33_;
	gint64 _tmp34_;
	ChessState* _tmp35_;
	ChessState* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = chess_state_new_empty ();
	state = _tmp0_;
	_tmp1_ = state;
	_tmp1_->number = self->number;
	_tmp2_ = state;
	_tmp3_ = self->players[COLOR_WHITE];
	_tmp4_ = _g_object_ref0 (_tmp3_);
	_g_object_unref0 (_tmp2_->players[COLOR_WHITE]);
	_tmp2_->players[COLOR_WHITE] = _tmp4_;
	_tmp5_ = state;
	_tmp6_ = self->players[COLOR_BLACK];
	_tmp7_ = _g_object_ref0 (_tmp6_);
	_g_object_unref0 (_tmp5_->players[COLOR_BLACK]);
	_tmp5_->players[COLOR_BLACK] = _tmp7_;
	_tmp8_ = state;
	_tmp9_ = self->current_player;
	_tmp10_ = _g_object_ref0 (_tmp9_);
	_g_object_unref0 (_tmp8_->current_player);
	_tmp8_->current_player = _tmp10_;
	_tmp11_ = state;
	_tmp12_ = self->can_castle_kingside[COLOR_WHITE];
	_tmp11_->can_castle_kingside[COLOR_WHITE] = _tmp12_;
	_tmp13_ = state;
	_tmp14_ = self->can_castle_queenside[COLOR_WHITE];
	_tmp13_->can_castle_queenside[COLOR_WHITE] = _tmp14_;
	_tmp15_ = state;
	_tmp16_ = self->can_castle_kingside[COLOR_BLACK];
	_tmp15_->can_castle_kingside[COLOR_BLACK] = _tmp16_;
	_tmp17_ = state;
	_tmp18_ = self->can_castle_queenside[COLOR_BLACK];
	_tmp17_->can_castle_queenside[COLOR_BLACK] = _tmp18_;
	_tmp19_ = state;
	_tmp19_->en_passant_index = self->en_passant_index;
	_tmp20_ = state;
	_tmp21_ = self->check_state;
	_tmp20_->check_state = _tmp21_;
	_tmp22_ = self->last_move;
	if (_tmp22_ != NULL) {
		ChessState* _tmp23_;
		ChessMove* _tmp24_;
		ChessMove* _tmp25_;
		_tmp23_ = state;
		_tmp24_ = self->last_move;
		_tmp25_ = chess_move_copy (_tmp24_);
		_g_object_unref0 (_tmp23_->last_move);
		_tmp23_->last_move = _tmp25_;
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp26_ = FALSE;
			_tmp26_ = TRUE;
			while (TRUE) {
				ChessState* _tmp28_;
				ChessPiece* _tmp29_;
				ChessPiece* _tmp30_;
				if (!_tmp26_) {
					gint _tmp27_;
					_tmp27_ = i;
					i = _tmp27_ + 1;
				}
				_tmp26_ = FALSE;
				if (!(i < 64)) {
					break;
				}
				_tmp28_ = state;
				_tmp29_ = self->board[i];
				_tmp30_ = _g_object_ref0 (_tmp29_);
				_g_object_unref0 (_tmp28_->board[i]);
				_tmp28_->board[i] = _tmp30_;
			}
		}
	}
	_tmp31_ = state;
	_tmp32_ = self->priv->piece_masks[COLOR_WHITE];
	_tmp31_->priv->piece_masks[COLOR_WHITE] = _tmp32_;
	_tmp33_ = state;
	_tmp34_ = self->priv->piece_masks[COLOR_BLACK];
	_tmp33_->priv->piece_masks[COLOR_BLACK] = _tmp34_;
	_tmp35_ = state;
	_tmp35_->halfmove_clock = self->halfmove_clock;
	result = state;
	return result;
}

gboolean
chess_state_equals (ChessState* self,
                    ChessState* state)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gint64 _tmp7_;
	gint64 _tmp8_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (state != NULL, FALSE);
	_tmp7_ = self->priv->piece_masks[COLOR_WHITE];
	_tmp8_ = state->priv->piece_masks[COLOR_WHITE];
	if (_tmp7_ != _tmp8_) {
		_tmp6_ = TRUE;
	} else {
		gint64 _tmp9_;
		gint64 _tmp10_;
		_tmp9_ = self->priv->piece_masks[COLOR_BLACK];
		_tmp10_ = state->priv->piece_masks[COLOR_BLACK];
		_tmp6_ = _tmp9_ != _tmp10_;
	}
	if (_tmp6_) {
		_tmp5_ = TRUE;
	} else {
		ChessPlayer* _tmp11_;
		Color _tmp12_;
		ChessPlayer* _tmp13_;
		Color _tmp14_;
		_tmp11_ = self->current_player;
		_tmp12_ = _tmp11_->color;
		_tmp13_ = state->current_player;
		_tmp14_ = _tmp13_->color;
		_tmp5_ = _tmp12_ != _tmp14_;
	}
	if (_tmp5_) {
		_tmp4_ = TRUE;
	} else {
		gboolean _tmp15_;
		gboolean _tmp16_;
		_tmp15_ = self->can_castle_kingside[COLOR_WHITE];
		_tmp16_ = state->can_castle_kingside[COLOR_WHITE];
		_tmp4_ = _tmp15_ != _tmp16_;
	}
	if (_tmp4_) {
		_tmp3_ = TRUE;
	} else {
		gboolean _tmp17_;
		gboolean _tmp18_;
		_tmp17_ = self->can_castle_queenside[COLOR_WHITE];
		_tmp18_ = state->can_castle_queenside[COLOR_WHITE];
		_tmp3_ = _tmp17_ != _tmp18_;
	}
	if (_tmp3_) {
		_tmp2_ = TRUE;
	} else {
		gboolean _tmp19_;
		gboolean _tmp20_;
		_tmp19_ = self->can_castle_kingside[COLOR_BLACK];
		_tmp20_ = state->can_castle_kingside[COLOR_BLACK];
		_tmp2_ = _tmp19_ != _tmp20_;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		gboolean _tmp21_;
		gboolean _tmp22_;
		_tmp21_ = self->can_castle_queenside[COLOR_BLACK];
		_tmp22_ = state->can_castle_queenside[COLOR_BLACK];
		_tmp1_ = _tmp21_ != _tmp22_;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = self->en_passant_index != state->en_passant_index;
	}
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp23_ = FALSE;
			_tmp23_ = TRUE;
			while (TRUE) {
				gboolean _tmp25_ = FALSE;
				ChessPiece* _tmp26_;
				if (!_tmp23_) {
					gint _tmp24_;
					_tmp24_ = i;
					i = _tmp24_ + 1;
				}
				_tmp23_ = FALSE;
				if (!(i < 64)) {
					break;
				}
				_tmp26_ = self->board[i];
				if (_tmp26_ != NULL) {
					ChessPiece* _tmp27_;
					PieceType _tmp28_;
					ChessPiece* _tmp29_;
					PieceType _tmp30_;
					_tmp27_ = self->board[i];
					_tmp28_ = _tmp27_->type;
					_tmp29_ = state->board[i];
					_tmp30_ = _tmp29_->type;
					_tmp25_ = _tmp28_ != _tmp30_;
				} else {
					_tmp25_ = FALSE;
				}
				if (_tmp25_) {
					result = FALSE;
					return result;
				}
			}
		}
	}
	result = TRUE;
	return result;
}

gchar*
chess_state_get_fen (ChessState* self)
{
	GString* value = NULL;
	GString* _tmp0_;
	GString* _tmp16_;
	ChessPlayer* _tmp17_;
	Color _tmp18_;
	GString* _tmp21_;
	gboolean _tmp22_;
	gboolean _tmp24_;
	gboolean _tmp26_;
	gboolean _tmp28_;
	gboolean _tmp30_;
	gboolean _tmp31_;
	gboolean _tmp32_;
	gboolean _tmp33_;
	GString* _tmp35_;
	GString* _tmp38_;
	GString* _tmp39_;
	GString* _tmp40_;
	ChessPlayer* _tmp41_;
	Color _tmp42_;
	GString* _tmp45_;
	const gchar* _tmp46_;
	gchar* _tmp47_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_string_new ("");
	value = _tmp0_;
	{
		gint rank = 0;
		rank = 7;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				gint skip_count = 0;
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = rank;
					rank = _tmp2_ - 1;
				}
				_tmp1_ = FALSE;
				if (!(rank >= 0)) {
					break;
				}
				skip_count = 0;
				{
					gint file = 0;
					file = 0;
					{
						gboolean _tmp3_ = FALSE;
						_tmp3_ = TRUE;
						while (TRUE) {
							ChessPiece* p = NULL;
							ChessPiece* _tmp5_;
							ChessPiece* _tmp6_;
							ChessPiece* _tmp7_;
							if (!_tmp3_) {
								gint _tmp4_;
								_tmp4_ = file;
								file = _tmp4_ + 1;
							}
							_tmp3_ = FALSE;
							if (!(file < 8)) {
								break;
							}
							_tmp5_ = self->board[chess_state_get_index (self, rank, file)];
							_tmp6_ = _g_object_ref0 (_tmp5_);
							p = _tmp6_;
							_tmp7_ = p;
							if (_tmp7_ == NULL) {
								gint _tmp8_;
								_tmp8_ = skip_count;
								skip_count = _tmp8_ + 1;
							} else {
								GString* _tmp10_;
								ChessPiece* _tmp11_;
								gunichar _tmp12_;
								gunichar _tmp13_;
								if (skip_count > 0) {
									GString* _tmp9_;
									_tmp9_ = value;
									g_string_append_printf (_tmp9_, "%d", skip_count);
									skip_count = 0;
								}
								_tmp10_ = value;
								_tmp11_ = p;
								_tmp12_ = chess_piece_get_symbol (_tmp11_);
								_tmp13_ = _tmp12_;
								g_string_append_printf (_tmp10_, "%c", (gint) _tmp13_);
							}
							_g_object_unref0 (p);
						}
					}
				}
				if (skip_count > 0) {
					GString* _tmp14_;
					_tmp14_ = value;
					g_string_append_printf (_tmp14_, "%d", skip_count);
				}
				if (rank != 0) {
					GString* _tmp15_;
					_tmp15_ = value;
					g_string_append_c (_tmp15_, '/');
				}
			}
		}
	}
	_tmp16_ = value;
	g_string_append_c (_tmp16_, ' ');
	_tmp17_ = self->current_player;
	_tmp18_ = _tmp17_->color;
	if (_tmp18_ == COLOR_WHITE) {
		GString* _tmp19_;
		_tmp19_ = value;
		g_string_append_c (_tmp19_, 'w');
	} else {
		GString* _tmp20_;
		_tmp20_ = value;
		g_string_append_c (_tmp20_, 'b');
	}
	_tmp21_ = value;
	g_string_append_c (_tmp21_, ' ');
	_tmp22_ = self->can_castle_kingside[COLOR_WHITE];
	if (_tmp22_) {
		GString* _tmp23_;
		_tmp23_ = value;
		g_string_append_c (_tmp23_, 'K');
	}
	_tmp24_ = self->can_castle_queenside[COLOR_WHITE];
	if (_tmp24_) {
		GString* _tmp25_;
		_tmp25_ = value;
		g_string_append_c (_tmp25_, 'Q');
	}
	_tmp26_ = self->can_castle_kingside[COLOR_BLACK];
	if (_tmp26_) {
		GString* _tmp27_;
		_tmp27_ = value;
		g_string_append_c (_tmp27_, 'k');
	}
	_tmp28_ = self->can_castle_queenside[COLOR_BLACK];
	if (_tmp28_) {
		GString* _tmp29_;
		_tmp29_ = value;
		g_string_append_c (_tmp29_, 'q');
	}
	_tmp30_ = self->can_castle_kingside[COLOR_WHITE];
	_tmp31_ = self->can_castle_queenside[COLOR_WHITE];
	_tmp32_ = self->can_castle_kingside[COLOR_BLACK];
	_tmp33_ = self->can_castle_queenside[COLOR_BLACK];
	if (!(((_tmp30_ | _tmp31_) | _tmp32_) | _tmp33_)) {
		GString* _tmp34_;
		_tmp34_ = value;
		g_string_append_c (_tmp34_, '-');
	}
	_tmp35_ = value;
	g_string_append_c (_tmp35_, ' ');
	if (self->en_passant_index >= 0) {
		GString* _tmp36_;
		_tmp36_ = value;
		g_string_append_printf (_tmp36_, "%c%d", 'a' + chess_state_get_file (self, self->en_passant_index), chess_state_get_rank (self, self->en_passant_index) + 1);
	} else {
		GString* _tmp37_;
		_tmp37_ = value;
		g_string_append_c (_tmp37_, '-');
	}
	_tmp38_ = value;
	g_string_append_c (_tmp38_, ' ');
	_tmp39_ = value;
	g_string_append_printf (_tmp39_, "%d", self->halfmove_clock);
	_tmp40_ = value;
	g_string_append_c (_tmp40_, ' ');
	_tmp41_ = self->current_player;
	_tmp42_ = _tmp41_->color;
	if (_tmp42_ == COLOR_WHITE) {
		GString* _tmp43_;
		_tmp43_ = value;
		g_string_append_printf (_tmp43_, "%d", self->number / 2);
	} else {
		GString* _tmp44_;
		_tmp44_ = value;
		g_string_append_printf (_tmp44_, "%d", (self->number / 2) + 1);
	}
	_tmp45_ = value;
	_tmp46_ = _tmp45_->str;
	_tmp47_ = g_strdup (_tmp46_);
	result = _tmp47_;
	_g_string_free0 (value);
	return result;
}

gint
chess_state_get_index (ChessState* self,
                       gint rank,
                       gint file)
{
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	result = (rank * 8) + file;
	return result;
}

gint
chess_state_get_rank (ChessState* self,
                      gint index)
{
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	result = index / 8;
	return result;
}

gint
chess_state_get_file (ChessState* self,
                      gint index)
{
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	result = index % 8;
	return result;
}

gboolean
chess_state_move (ChessState* self,
                  const gchar* move,
                  gboolean apply)
{
	gint r0 = 0;
	gint f0 = 0;
	gint r1 = 0;
	gint f1 = 0;
	PieceType promotion_type = 0;
	ChessPlayer* _tmp0_;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	PieceType _tmp5_ = 0;
	gboolean _tmp6_;
	ChessPlayer* _tmp7_;
	PieceType _tmp8_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (move != NULL, FALSE);
	_tmp0_ = self->current_player;
	_tmp6_ = chess_state_decode_move (self, _tmp0_, move, &_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
	r0 = _tmp1_;
	f0 = _tmp2_;
	r1 = _tmp3_;
	f1 = _tmp4_;
	promotion_type = _tmp5_;
	if (!_tmp6_) {
		result = FALSE;
		return result;
	}
	_tmp7_ = self->current_player;
	_tmp8_ = promotion_type;
	if (!chess_state_move_with_coords (self, _tmp7_, r0, f0, r1, f1, _tmp8_, apply, TRUE)) {
		result = FALSE;
		return result;
	}
	result = TRUE;
	return result;
}

gboolean
chess_state_move_with_coords (ChessState* self,
                              ChessPlayer* player,
                              gint r0,
                              gint f0,
                              gint r1,
                              gint f1,
                              PieceType promotion_type,
                              gboolean apply,
                              gboolean test_check)
{
	gint start = 0;
	gint end = 0;
	Color color = 0;
	Color _tmp0_;
	Color _tmp1_ = 0;
	Color _tmp2_;
	Color opponent_color = 0;
	ChessPiece* piece = NULL;
	ChessPiece* _tmp3_;
	ChessPiece* _tmp4_;
	gboolean _tmp5_ = FALSE;
	ChessPiece* _tmp6_;
	gint64 end_mask = 0LL;
	gint64 _tmp9_;
	gint64 move_mask = 0LL;
	Color _tmp10_;
	ChessPiece* _tmp11_;
	PieceType _tmp12_;
	gint64 _tmp13_;
	gint64 over_mask = 0LL;
	gint64 _tmp14_;
	gint64 _tmp15_;
	gint64 _tmp16_;
	ChessPiece* victim = NULL;
	ChessPiece* _tmp17_;
	ChessPiece* _tmp18_;
	gint victim_index = 0;
	gboolean _tmp19_ = FALSE;
	ChessPiece* _tmp20_;
	gint rook_start = 0;
	gint rook_end = 0;
	gboolean is_promotion = FALSE;
	gboolean en_passant = FALSE;
	gboolean ambiguous_rank = FALSE;
	gboolean ambiguous_file = FALSE;
	ChessPiece* _tmp23_;
	PieceType _tmp24_;
	gboolean _tmp55_ = FALSE;
	gint64 old_white_mask = 0LL;
	gint64 _tmp69_;
	gint64 old_black_mask = 0LL;
	gint64 _tmp70_;
	gboolean old_white_can_castle_kingside = FALSE;
	gboolean _tmp71_;
	gboolean old_white_can_castle_queenside = FALSE;
	gboolean _tmp72_;
	gboolean old_black_can_castle_kingside = FALSE;
	gboolean _tmp73_;
	gboolean old_black_can_castle_queenside = FALSE;
	gboolean _tmp74_;
	gint old_en_passant_index = 0;
	gint old_halfmove_clock = 0;
	gint64 _tmp75_;
	gint64 _tmp76_;
	ChessPiece* _tmp77_;
	Color _tmp83_;
	Color _tmp84_;
	gint64 _tmp85_;
	ChessPiece* _tmp94_;
	PieceType _tmp95_;
	gboolean _tmp112_ = FALSE;
	ChessPiece* _tmp113_;
	PieceType _tmp114_;
	gboolean _tmp115_ = FALSE;
	ChessPiece* _tmp116_;
	PieceType _tmp117_;
	gboolean _result_ = FALSE;
	gboolean _tmp120_ = FALSE;
	gboolean _tmp121_ = FALSE;
	ChessPlayer* _tmp131_ = NULL;
	Color _tmp132_;
	ChessPlayer* _tmp135_;
	ChessPlayer* _tmp136_;
	ChessMove* _tmp137_;
	ChessMove* _tmp138_;
	ChessMove* _tmp139_;
	ChessPiece* _tmp140_;
	ChessPiece* _tmp141_;
	ChessMove* _tmp145_;
	ChessPiece* _tmp146_;
	ChessPiece* _tmp147_;
	ChessMove* _tmp151_;
	ChessMove* _tmp152_;
	ChessMove* _tmp153_;
	ChessMove* _tmp154_;
	ChessMove* _tmp155_;
	ChessMove* _tmp156_;
	ChessMove* _tmp157_;
	ChessMove* _tmp158_;
	CheckState _tmp159_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (player != NULL, FALSE);
	start = chess_state_get_index (self, r0, f0);
	end = chess_state_get_index (self, r1, f1);
	_tmp0_ = player->color;
	color = _tmp0_;
	_tmp2_ = color;
	if (_tmp2_ == COLOR_WHITE) {
		_tmp1_ = COLOR_BLACK;
	} else {
		_tmp1_ = COLOR_WHITE;
	}
	opponent_color = _tmp1_;
	_tmp3_ = self->board[start];
	_tmp4_ = _g_object_ref0 (_tmp3_);
	piece = _tmp4_;
	_tmp6_ = piece;
	if (_tmp6_ == NULL) {
		_tmp5_ = TRUE;
	} else {
		ChessPiece* _tmp7_;
		ChessPlayer* _tmp8_;
		_tmp7_ = piece;
		_tmp8_ = _tmp7_->player;
		_tmp5_ = _tmp8_ != player;
	}
	if (_tmp5_) {
		result = FALSE;
		_g_object_unref0 (piece);
		return result;
	}
	_tmp9_ = BIT_BOARD_set_location_masks[end];
	end_mask = _tmp9_;
	_tmp10_ = color;
	_tmp11_ = piece;
	_tmp12_ = _tmp11_->type;
	_tmp13_ = BIT_BOARD_move_masks[(((_tmp10_ * 64) * 6) + (_tmp12_ * 64)) + start];
	move_mask = _tmp13_;
	if ((end_mask & move_mask) == ((gint64) 0)) {
		result = FALSE;
		_g_object_unref0 (piece);
		return result;
	}
	_tmp14_ = BIT_BOARD_over_masks[(start * 64) + end];
	over_mask = _tmp14_;
	_tmp15_ = self->priv->piece_masks[COLOR_WHITE];
	_tmp16_ = self->priv->piece_masks[COLOR_BLACK];
	if ((over_mask & (_tmp15_ | _tmp16_)) != ((gint64) 0)) {
		result = FALSE;
		_g_object_unref0 (piece);
		return result;
	}
	_tmp17_ = self->board[end];
	_tmp18_ = _g_object_ref0 (_tmp17_);
	victim = _tmp18_;
	victim_index = end;
	_tmp20_ = victim;
	if (_tmp20_ != NULL) {
		ChessPiece* _tmp21_;
		ChessPlayer* _tmp22_;
		_tmp21_ = victim;
		_tmp22_ = _tmp21_->player;
		_tmp19_ = _tmp22_ == player;
	} else {
		_tmp19_ = FALSE;
	}
	if (_tmp19_) {
		result = FALSE;
		_g_object_unref0 (victim);
		_g_object_unref0 (piece);
		return result;
	}
	rook_start = -1;
	rook_end = -1;
	is_promotion = FALSE;
	en_passant = FALSE;
	ambiguous_rank = FALSE;
	ambiguous_file = FALSE;
	_tmp23_ = piece;
	_tmp24_ = _tmp23_->type;
	switch (_tmp24_) {
		case PIECE_TYPE_PAWN:
		{
			gboolean _tmp25_ = FALSE;
			ChessPiece* _tmp26_;
			gboolean _tmp32_ = FALSE;
			ChessPiece* _tmp33_;
			_tmp26_ = victim;
			if (_tmp26_ == NULL) {
				_tmp25_ = end == self->en_passant_index;
			} else {
				_tmp25_ = FALSE;
			}
			if (_tmp25_) {
				gint _tmp27_ = 0;
				ChessPiece* _tmp28_;
				ChessPiece* _tmp29_;
				en_passant = TRUE;
				if (r1 == 2) {
					_tmp27_ = 3;
				} else {
					_tmp27_ = 4;
				}
				victim_index = chess_state_get_index (self, _tmp27_, f1);
				_tmp28_ = self->board[victim_index];
				_tmp29_ = _g_object_ref0 (_tmp28_);
				_g_object_unref0 (victim);
				victim = _tmp29_;
			}
			if (f0 != f1) {
				ChessPiece* _tmp30_;
				_tmp30_ = victim;
				if (_tmp30_ == NULL) {
					result = FALSE;
					_g_object_unref0 (victim);
					_g_object_unref0 (piece);
					return result;
				}
			} else {
				ChessPiece* _tmp31_;
				_tmp31_ = victim;
				if (_tmp31_ != NULL) {
					result = FALSE;
					_g_object_unref0 (victim);
					_g_object_unref0 (piece);
					return result;
				}
			}
			if (r1 == 0) {
				_tmp32_ = TRUE;
			} else {
				_tmp32_ = r1 == 7;
			}
			is_promotion = _tmp32_;
			_tmp33_ = victim;
			if (_tmp33_ != NULL) {
				ambiguous_file = TRUE;
			}
			break;
		}
		case PIECE_TYPE_KING:
		{
			if (abs (f0 - f1) > 1) {
				gint _tmp34_ = 0;
				gint _tmp35_ = 0;
				ChessPiece* rook = NULL;
				ChessPiece* _tmp40_;
				ChessPiece* _tmp41_;
				gboolean _tmp42_ = FALSE;
				gboolean _tmp43_ = FALSE;
				ChessPiece* _tmp44_;
				gint64 rook_over_mask = 0LL;
				gint64 _tmp51_;
				gint64 _tmp52_;
				gint64 _tmp53_;
				CheckState _tmp54_;
				if (f1 > f0) {
					_tmp34_ = 7;
				} else {
					_tmp34_ = 0;
				}
				rook_start = chess_state_get_index (self, r0, _tmp34_);
				if (f1 > f0) {
					_tmp35_ = f1 - 1;
				} else {
					_tmp35_ = f1 + 1;
				}
				rook_end = chess_state_get_index (self, r0, _tmp35_);
				if (f1 > f0) {
					Color _tmp36_;
					gboolean _tmp37_;
					_tmp36_ = color;
					_tmp37_ = self->can_castle_kingside[_tmp36_];
					if (!_tmp37_) {
						result = FALSE;
						_g_object_unref0 (victim);
						_g_object_unref0 (piece);
						return result;
					}
				} else {
					Color _tmp38_;
					gboolean _tmp39_;
					_tmp38_ = color;
					_tmp39_ = self->can_castle_queenside[_tmp38_];
					if (!_tmp39_) {
						result = FALSE;
						_g_object_unref0 (victim);
						_g_object_unref0 (piece);
						return result;
					}
				}
				_tmp40_ = self->board[rook_start];
				_tmp41_ = _g_object_ref0 (_tmp40_);
				rook = _tmp41_;
				_tmp44_ = rook;
				if (_tmp44_ == NULL) {
					_tmp43_ = TRUE;
				} else {
					ChessPiece* _tmp45_;
					PieceType _tmp46_;
					_tmp45_ = rook;
					_tmp46_ = _tmp45_->type;
					_tmp43_ = _tmp46_ != PIECE_TYPE_ROOK;
				}
				if (_tmp43_) {
					_tmp42_ = TRUE;
				} else {
					ChessPiece* _tmp47_;
					Color _tmp48_;
					Color _tmp49_;
					Color _tmp50_;
					_tmp47_ = rook;
					_tmp48_ = chess_piece_get_color (_tmp47_);
					_tmp49_ = _tmp48_;
					_tmp50_ = color;
					_tmp42_ = _tmp49_ != _tmp50_;
				}
				if (_tmp42_) {
					result = FALSE;
					_g_object_unref0 (rook);
					_g_object_unref0 (victim);
					_g_object_unref0 (piece);
					return result;
				}
				_tmp51_ = BIT_BOARD_over_masks[(rook_start * 64) + rook_end];
				rook_over_mask = _tmp51_;
				_tmp52_ = self->priv->piece_masks[COLOR_WHITE];
				_tmp53_ = self->priv->piece_masks[COLOR_BLACK];
				if ((rook_over_mask & (_tmp52_ | _tmp53_)) != ((gint64) 0)) {
					result = FALSE;
					_g_object_unref0 (rook);
					_g_object_unref0 (victim);
					_g_object_unref0 (piece);
					return result;
				}
				_tmp54_ = self->check_state;
				if (_tmp54_ == CHECK_STATE_CHECK) {
					result = FALSE;
					_g_object_unref0 (rook);
					_g_object_unref0 (victim);
					_g_object_unref0 (piece);
					return result;
				}
				if (!chess_state_move_with_coords (self, player, r0, f0, chess_state_get_rank (self, rook_end), chess_state_get_file (self, rook_end), PIECE_TYPE_QUEEN, FALSE, TRUE)) {
					result = FALSE;
					_g_object_unref0 (rook);
					_g_object_unref0 (victim);
					_g_object_unref0 (piece);
					return result;
				}
				_g_object_unref0 (rook);
			}
			break;
		}
		default:
		{
			break;
		}
	}
	if (!apply) {
		_tmp55_ = !test_check;
	} else {
		_tmp55_ = FALSE;
	}
	if (_tmp55_) {
		result = TRUE;
		_g_object_unref0 (victim);
		_g_object_unref0 (piece);
		return result;
	}
	if (apply) {
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp56_ = FALSE;
				_tmp56_ = TRUE;
				while (TRUE) {
					ChessPiece* p = NULL;
					ChessPiece* _tmp58_;
					ChessPiece* _tmp59_;
					gboolean _tmp60_ = FALSE;
					gboolean _tmp61_ = FALSE;
					ChessPiece* _tmp62_;
					gint r = 0;
					gint f = 0;
					if (!_tmp56_) {
						gint _tmp57_;
						_tmp57_ = i;
						i = _tmp57_ + 1;
					}
					_tmp56_ = FALSE;
					if (!(i < 64)) {
						break;
					}
					if (i == start) {
						continue;
					}
					_tmp58_ = self->board[i];
					_tmp59_ = _g_object_ref0 (_tmp58_);
					p = _tmp59_;
					_tmp62_ = p;
					if (_tmp62_ == NULL) {
						_tmp61_ = TRUE;
					} else {
						ChessPiece* _tmp63_;
						ChessPlayer* _tmp64_;
						_tmp63_ = p;
						_tmp64_ = _tmp63_->player;
						_tmp61_ = _tmp64_ != player;
					}
					if (_tmp61_) {
						_tmp60_ = TRUE;
					} else {
						ChessPiece* _tmp65_;
						PieceType _tmp66_;
						ChessPiece* _tmp67_;
						PieceType _tmp68_;
						_tmp65_ = p;
						_tmp66_ = _tmp65_->type;
						_tmp67_ = piece;
						_tmp68_ = _tmp67_->type;
						_tmp60_ = _tmp66_ != _tmp68_;
					}
					if (_tmp60_) {
						_g_object_unref0 (p);
						continue;
					}
					r = chess_state_get_rank (self, i);
					f = chess_state_get_file (self, i);
					if (chess_state_move_with_coords (self, player, r, f, r1, f1, PIECE_TYPE_QUEEN, FALSE, TRUE)) {
						if (r != r0) {
							ambiguous_rank = TRUE;
						}
						if (f != f0) {
							ambiguous_file = TRUE;
						}
					}
					_g_object_unref0 (p);
				}
			}
		}
	}
	_tmp69_ = self->priv->piece_masks[COLOR_WHITE];
	old_white_mask = _tmp69_;
	_tmp70_ = self->priv->piece_masks[COLOR_BLACK];
	old_black_mask = _tmp70_;
	_tmp71_ = self->can_castle_kingside[COLOR_WHITE];
	old_white_can_castle_kingside = _tmp71_;
	_tmp72_ = self->can_castle_queenside[COLOR_WHITE];
	old_white_can_castle_queenside = _tmp72_;
	_tmp73_ = self->can_castle_kingside[COLOR_BLACK];
	old_black_can_castle_kingside = _tmp73_;
	_tmp74_ = self->can_castle_queenside[COLOR_BLACK];
	old_black_can_castle_queenside = _tmp74_;
	old_en_passant_index = self->en_passant_index;
	old_halfmove_clock = self->halfmove_clock;
	_g_object_unref0 (self->board[start]);
	self->board[start] = NULL;
	_tmp75_ = BIT_BOARD_clear_location_masks[start];
	self->priv->piece_masks[COLOR_WHITE] &= _tmp75_;
	_tmp76_ = BIT_BOARD_clear_location_masks[start];
	self->priv->piece_masks[COLOR_BLACK] &= _tmp76_;
	_tmp77_ = victim;
	if (_tmp77_ != NULL) {
		gint64 _tmp78_;
		gint64 _tmp79_;
		_g_object_unref0 (self->board[victim_index]);
		self->board[victim_index] = NULL;
		_tmp78_ = BIT_BOARD_clear_location_masks[victim_index];
		self->priv->piece_masks[COLOR_WHITE] &= _tmp78_;
		_tmp79_ = BIT_BOARD_clear_location_masks[victim_index];
		self->priv->piece_masks[COLOR_BLACK] &= _tmp79_;
	}
	if (is_promotion) {
		ChessPiece* _tmp80_;
		_tmp80_ = chess_piece_new (player, promotion_type);
		_g_object_unref0 (self->board[end]);
		self->board[end] = _tmp80_;
	} else {
		ChessPiece* _tmp81_;
		ChessPiece* _tmp82_;
		_tmp81_ = piece;
		_tmp82_ = _g_object_ref0 (_tmp81_);
		_g_object_unref0 (self->board[end]);
		self->board[end] = _tmp82_;
	}
	_tmp83_ = color;
	self->priv->piece_masks[_tmp83_] |= end_mask;
	_tmp84_ = opponent_color;
	_tmp85_ = BIT_BOARD_clear_location_masks[end];
	self->priv->piece_masks[_tmp84_] &= _tmp85_;
	if (rook_start >= 0) {
		ChessPiece* rook = NULL;
		ChessPiece* _tmp86_;
		ChessPiece* _tmp87_;
		Color _tmp88_;
		gint64 _tmp89_;
		ChessPiece* _tmp90_;
		ChessPiece* _tmp91_;
		Color _tmp92_;
		gint64 _tmp93_;
		_tmp86_ = self->board[rook_start];
		_tmp87_ = _g_object_ref0 (_tmp86_);
		rook = _tmp87_;
		_g_object_unref0 (self->board[rook_start]);
		self->board[rook_start] = NULL;
		_tmp88_ = color;
		_tmp89_ = BIT_BOARD_clear_location_masks[rook_start];
		self->priv->piece_masks[_tmp88_] &= _tmp89_;
		_tmp90_ = rook;
		_tmp91_ = _g_object_ref0 (_tmp90_);
		_g_object_unref0 (self->board[rook_end]);
		self->board[rook_end] = _tmp91_;
		_tmp92_ = color;
		_tmp93_ = BIT_BOARD_set_location_masks[rook_end];
		self->priv->piece_masks[_tmp92_] |= _tmp93_;
		_g_object_unref0 (rook);
	}
	_tmp94_ = piece;
	_tmp95_ = _tmp94_->type;
	if (_tmp95_ == PIECE_TYPE_KING) {
		Color _tmp96_;
		Color _tmp97_;
		_tmp96_ = color;
		self->can_castle_kingside[_tmp96_] = FALSE;
		_tmp97_ = color;
		self->can_castle_queenside[_tmp97_] = FALSE;
	} else {
		ChessPiece* _tmp98_;
		PieceType _tmp99_;
		_tmp98_ = piece;
		_tmp99_ = _tmp98_->type;
		if (_tmp99_ == PIECE_TYPE_ROOK) {
			gint _tmp100_ = 0;
			Color _tmp101_;
			gint base_rank = 0;
			_tmp101_ = color;
			if (_tmp101_ == COLOR_WHITE) {
				_tmp100_ = 0;
			} else {
				_tmp100_ = 7;
			}
			base_rank = _tmp100_;
			if (r0 == base_rank) {
				if (f0 == 0) {
					Color _tmp102_;
					_tmp102_ = color;
					self->can_castle_queenside[_tmp102_] = FALSE;
				} else {
					if (f0 == 7) {
						Color _tmp103_;
						_tmp103_ = color;
						self->can_castle_kingside[_tmp103_] = FALSE;
					}
				}
			}
		} else {
			gboolean _tmp104_ = FALSE;
			ChessPiece* _tmp105_;
			_tmp105_ = victim;
			if (_tmp105_ != NULL) {
				ChessPiece* _tmp106_;
				PieceType _tmp107_;
				_tmp106_ = victim;
				_tmp107_ = _tmp106_->type;
				_tmp104_ = _tmp107_ == PIECE_TYPE_ROOK;
			} else {
				_tmp104_ = FALSE;
			}
			if (_tmp104_) {
				gint _tmp108_ = 0;
				Color _tmp109_;
				gint base_rank = 0;
				_tmp109_ = opponent_color;
				if (_tmp109_ == COLOR_WHITE) {
					_tmp108_ = 0;
				} else {
					_tmp108_ = 7;
				}
				base_rank = _tmp108_;
				if (r1 == base_rank) {
					if (f1 == 0) {
						Color _tmp110_;
						_tmp110_ = opponent_color;
						self->can_castle_queenside[_tmp110_] = FALSE;
					} else {
						if (f1 == 7) {
							Color _tmp111_;
							_tmp111_ = opponent_color;
							self->can_castle_kingside[_tmp111_] = FALSE;
						}
					}
				}
			}
		}
	}
	_tmp113_ = piece;
	_tmp114_ = _tmp113_->type;
	if (_tmp114_ == PIECE_TYPE_PAWN) {
		_tmp112_ = over_mask != ((gint64) 0);
	} else {
		_tmp112_ = FALSE;
	}
	if (_tmp112_) {
		self->en_passant_index = chess_state_get_index (self, (r0 + r1) / 2, f0);
	} else {
		self->en_passant_index = -1;
	}
	_tmp116_ = piece;
	_tmp117_ = _tmp116_->type;
	if (_tmp117_ == PIECE_TYPE_PAWN) {
		_tmp115_ = TRUE;
	} else {
		ChessPiece* _tmp118_;
		_tmp118_ = victim;
		_tmp115_ = _tmp118_ != NULL;
	}
	if (_tmp115_) {
		self->halfmove_clock = 0;
	} else {
		gint _tmp119_;
		_tmp119_ = self->halfmove_clock;
		self->halfmove_clock = _tmp119_ + 1;
	}
	_result_ = TRUE;
	if (test_check) {
		_tmp120_ = chess_state_is_in_check (self, player);
	} else {
		_tmp120_ = FALSE;
	}
	if (_tmp120_) {
		_result_ = FALSE;
	}
	if (!apply) {
		_tmp121_ = TRUE;
	} else {
		_tmp121_ = !_result_;
	}
	if (_tmp121_) {
		ChessPiece* _tmp122_;
		ChessPiece* _tmp123_;
		ChessPiece* _tmp124_;
		_tmp122_ = piece;
		_tmp123_ = _g_object_ref0 (_tmp122_);
		_g_object_unref0 (self->board[start]);
		self->board[start] = _tmp123_;
		_g_object_unref0 (self->board[end]);
		self->board[end] = NULL;
		_tmp124_ = victim;
		if (_tmp124_ != NULL) {
			ChessPiece* _tmp125_;
			ChessPiece* _tmp126_;
			_tmp125_ = victim;
			_tmp126_ = _g_object_ref0 (_tmp125_);
			_g_object_unref0 (self->board[victim_index]);
			self->board[victim_index] = _tmp126_;
		}
		if (rook_start >= 0) {
			ChessPiece* rook = NULL;
			ChessPiece* _tmp127_;
			ChessPiece* _tmp128_;
			ChessPiece* _tmp129_;
			ChessPiece* _tmp130_;
			_tmp127_ = self->board[rook_end];
			_tmp128_ = _g_object_ref0 (_tmp127_);
			rook = _tmp128_;
			_tmp129_ = rook;
			_tmp130_ = _g_object_ref0 (_tmp129_);
			_g_object_unref0 (self->board[rook_start]);
			self->board[rook_start] = _tmp130_;
			_g_object_unref0 (self->board[rook_end]);
			self->board[rook_end] = NULL;
			_g_object_unref0 (rook);
		}
		self->priv->piece_masks[COLOR_WHITE] = old_white_mask;
		self->priv->piece_masks[COLOR_BLACK] = old_black_mask;
		self->can_castle_kingside[COLOR_WHITE] = old_white_can_castle_kingside;
		self->can_castle_queenside[COLOR_WHITE] = old_white_can_castle_queenside;
		self->can_castle_kingside[COLOR_BLACK] = old_black_can_castle_kingside;
		self->can_castle_queenside[COLOR_BLACK] = old_black_can_castle_queenside;
		self->en_passant_index = old_en_passant_index;
		self->halfmove_clock = old_halfmove_clock;
		result = _result_;
		_g_object_unref0 (victim);
		_g_object_unref0 (piece);
		return result;
	}
	_tmp132_ = color;
	if (_tmp132_ == COLOR_WHITE) {
		ChessPlayer* _tmp133_;
		_tmp133_ = self->players[COLOR_BLACK];
		_tmp131_ = _tmp133_;
	} else {
		ChessPlayer* _tmp134_;
		_tmp134_ = self->players[COLOR_WHITE];
		_tmp131_ = _tmp134_;
	}
	_tmp135_ = _g_object_ref0 (_tmp131_);
	_g_object_unref0 (self->current_player);
	self->current_player = _tmp135_;
	_tmp136_ = self->current_player;
	self->check_state = chess_state_get_check_state (self, _tmp136_);
	_tmp137_ = chess_move_new ();
	_g_object_unref0 (self->last_move);
	self->last_move = _tmp137_;
	_tmp138_ = self->last_move;
	_tmp138_->number = self->number;
	_tmp139_ = self->last_move;
	_tmp140_ = piece;
	_tmp141_ = _g_object_ref0 (_tmp140_);
	_g_object_unref0 (_tmp139_->piece);
	_tmp139_->piece = _tmp141_;
	if (is_promotion) {
		ChessMove* _tmp142_;
		ChessPiece* _tmp143_;
		ChessPiece* _tmp144_;
		_tmp142_ = self->last_move;
		_tmp143_ = self->board[end];
		_tmp144_ = _g_object_ref0 (_tmp143_);
		_g_object_unref0 (_tmp142_->promotion_piece);
		_tmp142_->promotion_piece = _tmp144_;
	}
	_tmp145_ = self->last_move;
	_tmp146_ = victim;
	_tmp147_ = _g_object_ref0 (_tmp146_);
	_g_object_unref0 (_tmp145_->victim);
	_tmp145_->victim = _tmp147_;
	if (rook_end >= 0) {
		ChessMove* _tmp148_;
		ChessPiece* _tmp149_;
		ChessPiece* _tmp150_;
		_tmp148_ = self->last_move;
		_tmp149_ = self->board[rook_end];
		_tmp150_ = _g_object_ref0 (_tmp149_);
		_g_object_unref0 (_tmp148_->castling_rook);
		_tmp148_->castling_rook = _tmp150_;
	}
	_tmp151_ = self->last_move;
	_tmp151_->r0 = r0;
	_tmp152_ = self->last_move;
	_tmp152_->f0 = f0;
	_tmp153_ = self->last_move;
	_tmp153_->r1 = r1;
	_tmp154_ = self->last_move;
	_tmp154_->f1 = f1;
	_tmp155_ = self->last_move;
	_tmp155_->ambiguous_rank = ambiguous_rank;
	_tmp156_ = self->last_move;
	_tmp156_->ambiguous_file = ambiguous_file;
	_tmp157_ = self->last_move;
	_tmp157_->en_passant = en_passant;
	_tmp158_ = self->last_move;
	_tmp159_ = self->check_state;
	_tmp158_->check_state = _tmp159_;
	result = TRUE;
	_g_object_unref0 (victim);
	_g_object_unref0 (piece);
	return result;
}

ChessResult
chess_state_get_result (ChessState* self,
                        ChessRule* rule)
{
	ChessRule _vala_rule = 0;
	CheckState _tmp0_;
	ChessPlayer* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	ChessMove* _tmp6_;
	ChessResult result = 0;
	g_return_val_if_fail (self != NULL, 0);
	_vala_rule = CHESS_RULE_CHECKMATE;
	_tmp0_ = self->check_state;
	if (_tmp0_ == CHECK_STATE_CHECKMATE) {
		ChessPlayer* _tmp1_;
		Color _tmp2_;
		_tmp1_ = self->current_player;
		_tmp2_ = _tmp1_->color;
		if (_tmp2_ == COLOR_WHITE) {
			_vala_rule = CHESS_RULE_CHECKMATE;
			result = CHESS_RESULT_BLACK_WON;
			if (rule) {
				*rule = _vala_rule;
			}
			return result;
		} else {
			_vala_rule = CHESS_RULE_CHECKMATE;
			result = CHESS_RESULT_WHITE_WON;
			if (rule) {
				*rule = _vala_rule;
			}
			return result;
		}
	}
	_tmp3_ = self->current_player;
	if (!chess_state_can_move (self, _tmp3_)) {
		_vala_rule = CHESS_RULE_STALEMATE;
		result = CHESS_RESULT_DRAW;
		if (rule) {
			*rule = _vala_rule;
		}
		return result;
	}
	_tmp6_ = self->last_move;
	if (_tmp6_ != NULL) {
		ChessMove* _tmp7_;
		ChessPiece* _tmp8_;
		_tmp7_ = self->last_move;
		_tmp8_ = _tmp7_->victim;
		_tmp5_ = _tmp8_ != NULL;
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		_tmp4_ = !chess_state_have_sufficient_material (self);
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		_vala_rule = CHESS_RULE_INSUFFICIENT_MATERIAL;
		result = CHESS_RESULT_DRAW;
		if (rule) {
			*rule = _vala_rule;
		}
		return result;
	}
	result = CHESS_RESULT_IN_PROGRESS;
	if (rule) {
		*rule = _vala_rule;
	}
	return result;
}

static CheckState
chess_state_get_check_state (ChessState* self,
                             ChessPlayer* player)
{
	CheckState result = 0;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (player != NULL, 0);
	if (chess_state_is_in_check (self, player)) {
		if (chess_state_is_in_checkmate (self, player)) {
			result = CHECK_STATE_CHECKMATE;
			return result;
		} else {
			result = CHECK_STATE_CHECK;
			return result;
		}
	}
	result = CHECK_STATE_NONE;
	return result;
}

gboolean
chess_state_is_in_check (ChessState* self,
                         ChessPlayer* player)
{
	ChessPlayer* _tmp0_ = NULL;
	Color _tmp1_;
	ChessPlayer* opponent = NULL;
	ChessPlayer* _tmp4_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (player != NULL, FALSE);
	_tmp1_ = player->color;
	if (_tmp1_ == COLOR_WHITE) {
		ChessPlayer* _tmp2_;
		_tmp2_ = self->players[COLOR_BLACK];
		_tmp0_ = _tmp2_;
	} else {
		ChessPlayer* _tmp3_;
		_tmp3_ = self->players[COLOR_WHITE];
		_tmp0_ = _tmp3_;
	}
	_tmp4_ = _g_object_ref0 (_tmp0_);
	opponent = _tmp4_;
	{
		gint king_index = 0;
		king_index = 0;
		{
			gboolean _tmp5_ = FALSE;
			_tmp5_ = TRUE;
			while (TRUE) {
				ChessPiece* p = NULL;
				ChessPiece* _tmp7_;
				ChessPiece* _tmp8_;
				gboolean _tmp9_ = FALSE;
				gboolean _tmp10_ = FALSE;
				ChessPiece* _tmp11_;
				if (!_tmp5_) {
					gint _tmp6_;
					_tmp6_ = king_index;
					king_index = _tmp6_ + 1;
				}
				_tmp5_ = FALSE;
				if (!(king_index < 64)) {
					break;
				}
				_tmp7_ = self->board[king_index];
				_tmp8_ = _g_object_ref0 (_tmp7_);
				p = _tmp8_;
				_tmp11_ = p;
				if (_tmp11_ != NULL) {
					ChessPiece* _tmp12_;
					ChessPlayer* _tmp13_;
					_tmp12_ = p;
					_tmp13_ = _tmp12_->player;
					_tmp10_ = _tmp13_ == player;
				} else {
					_tmp10_ = FALSE;
				}
				if (_tmp10_) {
					ChessPiece* _tmp14_;
					PieceType _tmp15_;
					_tmp14_ = p;
					_tmp15_ = _tmp14_->type;
					_tmp9_ = _tmp15_ == PIECE_TYPE_KING;
				} else {
					_tmp9_ = FALSE;
				}
				if (_tmp9_) {
					{
						gint start = 0;
						start = 0;
						{
							gboolean _tmp16_ = FALSE;
							_tmp16_ = TRUE;
							while (TRUE) {
								ChessPlayer* _tmp18_;
								if (!_tmp16_) {
									gint _tmp17_;
									_tmp17_ = start;
									start = _tmp17_ + 1;
								}
								_tmp16_ = FALSE;
								if (!(start < 64)) {
									break;
								}
								_tmp18_ = opponent;
								if (chess_state_move_with_coords (self, _tmp18_, chess_state_get_rank (self, start), chess_state_get_file (self, start), chess_state_get_rank (self, king_index), chess_state_get_file (self, king_index), PIECE_TYPE_QUEEN, FALSE, FALSE)) {
									result = TRUE;
									_g_object_unref0 (p);
									_g_object_unref0 (opponent);
									return result;
								}
							}
						}
					}
				}
				_g_object_unref0 (p);
			}
		}
	}
	result = FALSE;
	_g_object_unref0 (opponent);
	return result;
}

static gboolean
chess_state_is_in_checkmate (ChessState* self,
                             ChessPlayer* player)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (player != NULL, FALSE);
	{
		gint piece_index = 0;
		piece_index = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				ChessPiece* p = NULL;
				ChessPiece* _tmp2_;
				ChessPiece* _tmp3_;
				gboolean _tmp4_ = FALSE;
				ChessPiece* _tmp5_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = piece_index;
					piece_index = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(piece_index < 64)) {
					break;
				}
				_tmp2_ = self->board[piece_index];
				_tmp3_ = _g_object_ref0 (_tmp2_);
				p = _tmp3_;
				_tmp5_ = p;
				if (_tmp5_ != NULL) {
					ChessPiece* _tmp6_;
					ChessPlayer* _tmp7_;
					_tmp6_ = p;
					_tmp7_ = _tmp6_->player;
					_tmp4_ = _tmp7_ == player;
				} else {
					_tmp4_ = FALSE;
				}
				if (_tmp4_) {
					{
						gint end = 0;
						end = 0;
						{
							gboolean _tmp8_ = FALSE;
							_tmp8_ = TRUE;
							while (TRUE) {
								if (!_tmp8_) {
									gint _tmp9_;
									_tmp9_ = end;
									end = _tmp9_ + 1;
								}
								_tmp8_ = FALSE;
								if (!(end < 64)) {
									break;
								}
								if (chess_state_move_with_coords (self, player, chess_state_get_rank (self, piece_index), chess_state_get_file (self, piece_index), chess_state_get_rank (self, end), chess_state_get_file (self, end), PIECE_TYPE_QUEEN, FALSE, TRUE)) {
									result = FALSE;
									_g_object_unref0 (p);
									return result;
								}
							}
						}
					}
				}
				_g_object_unref0 (p);
			}
		}
	}
	result = TRUE;
	return result;
}

static gboolean
chess_state_can_move (ChessState* self,
                      ChessPlayer* player)
{
	gboolean have_pieces = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (player != NULL, FALSE);
	have_pieces = FALSE;
	{
		gint start = 0;
		start = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				ChessPiece* p = NULL;
				ChessPiece* _tmp2_;
				ChessPiece* _tmp3_;
				gboolean _tmp4_ = FALSE;
				ChessPiece* _tmp5_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = start;
					start = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(start < 64)) {
					break;
				}
				_tmp2_ = self->board[start];
				_tmp3_ = _g_object_ref0 (_tmp2_);
				p = _tmp3_;
				_tmp5_ = p;
				if (_tmp5_ != NULL) {
					ChessPiece* _tmp6_;
					ChessPlayer* _tmp7_;
					_tmp6_ = p;
					_tmp7_ = _tmp6_->player;
					_tmp4_ = _tmp7_ == player;
				} else {
					_tmp4_ = FALSE;
				}
				if (_tmp4_) {
					have_pieces = TRUE;
					{
						gint end = 0;
						end = 0;
						{
							gboolean _tmp8_ = FALSE;
							_tmp8_ = TRUE;
							while (TRUE) {
								if (!_tmp8_) {
									gint _tmp9_;
									_tmp9_ = end;
									end = _tmp9_ + 1;
								}
								_tmp8_ = FALSE;
								if (!(end < 64)) {
									break;
								}
								if (chess_state_move_with_coords (self, player, chess_state_get_rank (self, start), chess_state_get_file (self, start), chess_state_get_rank (self, end), chess_state_get_file (self, end), PIECE_TYPE_QUEEN, FALSE, TRUE)) {
									result = TRUE;
									_g_object_unref0 (p);
									return result;
								}
							}
						}
					}
				}
				_g_object_unref0 (p);
			}
		}
	}
	if (have_pieces) {
		result = FALSE;
		return result;
	} else {
		result = TRUE;
		return result;
	}
}

gboolean
chess_state_have_sufficient_material (ChessState* self)
{
	gint white_knight_count = 0;
	gint white_bishop_count = 0;
	gboolean white_bishop_on_white_square = FALSE;
	gboolean white_bishop_on_black_square = FALSE;
	gint black_knight_count = 0;
	gint black_bishop_count = 0;
	gboolean black_bishop_on_white_square = FALSE;
	gboolean black_bishop_on_black_square = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	white_knight_count = 0;
	white_bishop_count = 0;
	white_bishop_on_white_square = FALSE;
	white_bishop_on_black_square = FALSE;
	black_knight_count = 0;
	black_bishop_count = 0;
	black_bishop_on_white_square = FALSE;
	black_bishop_on_black_square = FALSE;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				ChessPiece* p = NULL;
				ChessPiece* _tmp2_;
				ChessPiece* _tmp3_;
				ChessPiece* _tmp4_;
				gboolean _tmp5_ = FALSE;
				gboolean _tmp6_ = FALSE;
				ChessPiece* _tmp7_;
				PieceType _tmp8_;
				ChessPiece* _tmp13_;
				PieceType _tmp14_;
				ChessPiece* _tmp20_;
				PieceType _tmp21_;
				gboolean _tmp29_ = FALSE;
				gboolean _tmp30_ = FALSE;
				gboolean _tmp31_ = FALSE;
				gboolean _tmp32_ = FALSE;
				gboolean _tmp33_ = FALSE;
				gboolean _tmp34_ = FALSE;
				gboolean _tmp35_ = FALSE;
				gboolean _tmp36_ = FALSE;
				gboolean _tmp37_ = FALSE;
				gboolean _tmp38_ = FALSE;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(i < 64)) {
					break;
				}
				_tmp2_ = self->board[i];
				_tmp3_ = _g_object_ref0 (_tmp2_);
				p = _tmp3_;
				_tmp4_ = p;
				if (_tmp4_ == NULL) {
					_g_object_unref0 (p);
					continue;
				}
				_tmp7_ = p;
				_tmp8_ = _tmp7_->type;
				if (_tmp8_ == PIECE_TYPE_PAWN) {
					_tmp6_ = TRUE;
				} else {
					ChessPiece* _tmp9_;
					PieceType _tmp10_;
					_tmp9_ = p;
					_tmp10_ = _tmp9_->type;
					_tmp6_ = _tmp10_ == PIECE_TYPE_ROOK;
				}
				if (_tmp6_) {
					_tmp5_ = TRUE;
				} else {
					ChessPiece* _tmp11_;
					PieceType _tmp12_;
					_tmp11_ = p;
					_tmp12_ = _tmp11_->type;
					_tmp5_ = _tmp12_ == PIECE_TYPE_QUEEN;
				}
				if (_tmp5_) {
					result = TRUE;
					_g_object_unref0 (p);
					return result;
				}
				_tmp13_ = p;
				_tmp14_ = _tmp13_->type;
				if (_tmp14_ == PIECE_TYPE_KNIGHT) {
					ChessPiece* _tmp15_;
					Color _tmp16_;
					Color _tmp17_;
					_tmp15_ = p;
					_tmp16_ = chess_piece_get_color (_tmp15_);
					_tmp17_ = _tmp16_;
					if (_tmp17_ == COLOR_WHITE) {
						gint _tmp18_;
						_tmp18_ = white_knight_count;
						white_knight_count = _tmp18_ + 1;
					} else {
						gint _tmp19_;
						_tmp19_ = black_knight_count;
						black_knight_count = _tmp19_ + 1;
					}
				}
				_tmp20_ = p;
				_tmp21_ = _tmp20_->type;
				if (_tmp21_ == PIECE_TYPE_BISHOP) {
					Color color = 0;
					ChessPiece* _tmp22_;
					Color _tmp23_;
					Color _tmp24_;
					color = COLOR_BLACK;
					if (((i + (i / 8)) % 2) != 0) {
						color = COLOR_WHITE;
					}
					_tmp22_ = p;
					_tmp23_ = chess_piece_get_color (_tmp22_);
					_tmp24_ = _tmp23_;
					if (_tmp24_ == COLOR_WHITE) {
						Color _tmp25_;
						gint _tmp26_;
						_tmp25_ = color;
						if (_tmp25_ == COLOR_WHITE) {
							white_bishop_on_white_square = TRUE;
						} else {
							white_bishop_on_black_square = TRUE;
						}
						_tmp26_ = white_bishop_count;
						white_bishop_count = _tmp26_ + 1;
					} else {
						Color _tmp27_;
						gint _tmp28_;
						_tmp27_ = color;
						if (_tmp27_ == COLOR_WHITE) {
							black_bishop_on_white_square = TRUE;
						} else {
							black_bishop_on_black_square = TRUE;
						}
						_tmp28_ = black_bishop_count;
						black_bishop_count = _tmp28_ + 1;
					}
				}
				if (white_knight_count > 1) {
					_tmp29_ = TRUE;
				} else {
					_tmp29_ = black_knight_count > 1;
				}
				if (_tmp29_) {
					result = TRUE;
					_g_object_unref0 (p);
					return result;
				}
				if (white_bishop_count > 0) {
					_tmp30_ = white_knight_count > 0;
				} else {
					_tmp30_ = FALSE;
				}
				if (_tmp30_) {
					result = TRUE;
					_g_object_unref0 (p);
					return result;
				}
				if (black_bishop_count > 0) {
					_tmp31_ = black_knight_count > 0;
				} else {
					_tmp31_ = FALSE;
				}
				if (_tmp31_) {
					result = TRUE;
					_g_object_unref0 (p);
					return result;
				}
				if (white_bishop_on_white_square) {
					_tmp32_ = white_bishop_on_black_square;
				} else {
					_tmp32_ = FALSE;
				}
				if (_tmp32_) {
					result = TRUE;
					_g_object_unref0 (p);
					return result;
				}
				if (black_bishop_on_white_square) {
					_tmp33_ = black_bishop_on_black_square;
				} else {
					_tmp33_ = FALSE;
				}
				if (_tmp33_) {
					result = TRUE;
					_g_object_unref0 (p);
					return result;
				}
				if (white_bishop_count > 0) {
					_tmp35_ = TRUE;
				} else {
					_tmp35_ = white_knight_count > 0;
				}
				if (_tmp35_) {
					_tmp34_ = black_knight_count > 0;
				} else {
					_tmp34_ = FALSE;
				}
				if (_tmp34_) {
					result = TRUE;
					_g_object_unref0 (p);
					return result;
				}
				if (black_bishop_count > 0) {
					_tmp37_ = TRUE;
				} else {
					_tmp37_ = black_knight_count > 0;
				}
				if (_tmp37_) {
					_tmp36_ = white_knight_count > 0;
				} else {
					_tmp36_ = FALSE;
				}
				if (_tmp36_) {
					result = TRUE;
					_g_object_unref0 (p);
					return result;
				}
				if (white_bishop_count > 0) {
					_tmp38_ = black_bishop_count > 0;
				} else {
					_tmp38_ = FALSE;
				}
				if (_tmp38_) {
					gboolean _tmp39_ = FALSE;
					if (white_bishop_on_white_square) {
						_tmp39_ = black_bishop_on_black_square;
					} else {
						_tmp39_ = FALSE;
					}
					if (_tmp39_) {
						result = TRUE;
						_g_object_unref0 (p);
						return result;
					} else {
						gboolean _tmp40_ = FALSE;
						if (white_bishop_on_black_square) {
							_tmp40_ = black_bishop_on_white_square;
						} else {
							_tmp40_ = FALSE;
						}
						if (_tmp40_) {
							result = TRUE;
							_g_object_unref0 (p);
							return result;
						}
					}
				}
				_g_object_unref0 (p);
			}
		}
	}
	result = FALSE;
	return result;
}

static gboolean
chess_state_decode_piece_type (ChessState* self,
                               gunichar c,
                               PieceType* type)
{
	PieceType _vala_type = 0;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_vala_type = PIECE_TYPE_PAWN;
	switch (c) {
		case 'P':
		{
			_vala_type = PIECE_TYPE_PAWN;
			result = TRUE;
			if (type) {
				*type = _vala_type;
			}
			return result;
		}
		case 'R':
		{
			_vala_type = PIECE_TYPE_ROOK;
			result = TRUE;
			if (type) {
				*type = _vala_type;
			}
			return result;
		}
		case 'N':
		{
			_vala_type = PIECE_TYPE_KNIGHT;
			result = TRUE;
			if (type) {
				*type = _vala_type;
			}
			return result;
		}
		case 'B':
		{
			_vala_type = PIECE_TYPE_BISHOP;
			result = TRUE;
			if (type) {
				*type = _vala_type;
			}
			return result;
		}
		case 'Q':
		{
			_vala_type = PIECE_TYPE_QUEEN;
			result = TRUE;
			if (type) {
				*type = _vala_type;
			}
			return result;
		}
		case 'K':
		{
			_vala_type = PIECE_TYPE_KING;
			result = TRUE;
			if (type) {
				*type = _vala_type;
			}
			return result;
		}
		default:
		{
			result = FALSE;
			if (type) {
				*type = _vala_type;
			}
			return result;
		}
	}
	if (type) {
		*type = _vala_type;
	}
}

static gboolean
chess_state_decode_move (ChessState* self,
                         ChessPlayer* player,
                         const gchar* move,
                         gint* r0,
                         gint* f0,
                         gint* r1,
                         gint* f1,
                         PieceType* promotion_type)
{
	gint _vala_r0 = 0;
	gint _vala_f0 = 0;
	gint _vala_r1 = 0;
	gint _vala_f1 = 0;
	PieceType _vala_promotion_type = 0;
	gint i = 0;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (player != NULL, FALSE);
	g_return_val_if_fail (move != NULL, FALSE);
	i = 0;
	_vala_promotion_type = PIECE_TYPE_QUEEN;
	if (g_str_has_prefix (move, "O-O-O")) {
		Color _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		_tmp0_ = player->color;
		if (_tmp0_ == COLOR_WHITE) {
			_vala_r1 = 0;
			_vala_r0 = _vala_r1;
		} else {
			_vala_r1 = 7;
			_vala_r0 = _vala_r1;
		}
		_vala_f0 = 4;
		_vala_f1 = 2;
		_tmp1_ = strlen ("O-O-O");
		_tmp2_ = _tmp1_;
		i += (gint) _tmp2_;
	} else {
		if (g_str_has_prefix (move, "O-O")) {
			Color _tmp3_;
			gint _tmp4_;
			gint _tmp5_;
			_tmp3_ = player->color;
			if (_tmp3_ == COLOR_WHITE) {
				_vala_r1 = 0;
				_vala_r0 = _vala_r1;
			} else {
				_vala_r1 = 7;
				_vala_r0 = _vala_r1;
			}
			_vala_f0 = 4;
			_vala_f1 = 6;
			_tmp4_ = strlen ("O-O");
			_tmp5_ = _tmp4_;
			i += (gint) _tmp5_;
		} else {
			PieceType type = 0;
			PieceType _tmp6_ = 0;
			gboolean _tmp7_;
			gboolean _tmp9_ = FALSE;
			gboolean _tmp11_ = FALSE;
			gboolean _tmp13_ = FALSE;
			gboolean _tmp15_ = FALSE;
			gboolean _tmp17_ = FALSE;
			gboolean _tmp27_ = FALSE;
			gboolean _tmp28_ = FALSE;
			type = PIECE_TYPE_PAWN;
			_tmp7_ = chess_state_decode_piece_type (self, (gunichar) string_get (move, (glong) i), &_tmp6_);
			type = _tmp6_;
			if (_tmp7_) {
				gint _tmp8_;
				_tmp8_ = i;
				i = _tmp8_ + 1;
			}
			_vala_f1 = -1;
			_vala_r1 = _vala_f1;
			_vala_f0 = _vala_r1;
			_vala_r0 = _vala_f0;
			if (string_get (move, (glong) i) >= 'a') {
				_tmp9_ = string_get (move, (glong) i) <= 'h';
			} else {
				_tmp9_ = FALSE;
			}
			if (_tmp9_) {
				gint _tmp10_;
				_vala_f1 = (gint) (string_get (move, (glong) i) - 'a');
				_tmp10_ = i;
				i = _tmp10_ + 1;
			}
			if (string_get (move, (glong) i) >= '1') {
				_tmp11_ = string_get (move, (glong) i) <= '8';
			} else {
				_tmp11_ = FALSE;
			}
			if (_tmp11_) {
				gint _tmp12_;
				_vala_r1 = (gint) (string_get (move, (glong) i) - '1');
				_tmp12_ = i;
				i = _tmp12_ + 1;
			}
			if (string_get (move, (glong) i) == 'x') {
				_tmp13_ = TRUE;
			} else {
				_tmp13_ = string_get (move, (glong) i) == '-';
			}
			if (_tmp13_) {
				gint _tmp14_;
				_tmp14_ = i;
				i = _tmp14_ + 1;
			}
			if (string_get (move, (glong) i) >= 'a') {
				_tmp15_ = string_get (move, (glong) i) <= 'h';
			} else {
				_tmp15_ = FALSE;
			}
			if (_tmp15_) {
				gint _tmp16_;
				_vala_f0 = _vala_f1;
				_vala_f1 = (gint) (string_get (move, (glong) i) - 'a');
				_tmp16_ = i;
				i = _tmp16_ + 1;
			}
			if (string_get (move, (glong) i) >= '1') {
				_tmp17_ = string_get (move, (glong) i) <= '8';
			} else {
				_tmp17_ = FALSE;
			}
			if (_tmp17_) {
				gint _tmp18_;
				_vala_r0 = _vala_r1;
				_vala_r1 = (gint) (string_get (move, (glong) i) - '1');
				_tmp18_ = i;
				i = _tmp18_ + 1;
			}
			if (string_get (move, (glong) i) == '=') {
				gint _tmp19_;
				PieceType _tmp20_ = 0;
				gboolean _tmp21_;
				_tmp19_ = i;
				i = _tmp19_ + 1;
				_tmp21_ = chess_state_decode_piece_type (self, (gunichar) string_get (move, (glong) i), &_tmp20_);
				_vala_promotion_type = _tmp20_;
				if (_tmp21_) {
					gint _tmp22_;
					_tmp22_ = i;
					i = _tmp22_ + 1;
				}
			} else {
				if (string_get (move, (glong) i) != '\0') {
					switch (string_get (move, (glong) i)) {
						case 'q':
						case 'Q':
						{
							gint _tmp23_;
							_vala_promotion_type = PIECE_TYPE_QUEEN;
							_tmp23_ = i;
							i = _tmp23_ + 1;
							break;
						}
						case 'n':
						case 'N':
						{
							gint _tmp24_;
							_vala_promotion_type = PIECE_TYPE_KNIGHT;
							_tmp24_ = i;
							i = _tmp24_ + 1;
							break;
						}
						case 'r':
						case 'R':
						{
							gint _tmp25_;
							_vala_promotion_type = PIECE_TYPE_ROOK;
							_tmp25_ = i;
							i = _tmp25_ + 1;
							break;
						}
						case 'b':
						case 'B':
						{
							gint _tmp26_;
							_vala_promotion_type = PIECE_TYPE_BISHOP;
							_tmp26_ = i;
							i = _tmp26_ + 1;
							break;
						}
						default:
						break;
					}
				}
			}
			if (_vala_r1 < 0) {
				_tmp27_ = TRUE;
			} else {
				_tmp27_ = _vala_f1 < 0;
			}
			if (_tmp27_) {
				g_debug ("chess-state.vala:913: Move %s missing destination", move);
				result = FALSE;
				if (r0) {
					*r0 = _vala_r0;
				}
				if (f0) {
					*f0 = _vala_f0;
				}
				if (r1) {
					*r1 = _vala_r1;
				}
				if (f1) {
					*f1 = _vala_f1;
				}
				if (promotion_type) {
					*promotion_type = _vala_promotion_type;
				}
				return result;
			}
			if (_vala_r0 < 0) {
				_tmp28_ = TRUE;
			} else {
				_tmp28_ = _vala_f0 < 0;
			}
			if (_tmp28_) {
				gint match_rank = 0;
				gint match_file = 0;
				match_rank = -1;
				match_file = -1;
				{
					gint file = 0;
					file = 0;
					{
						gboolean _tmp29_ = FALSE;
						_tmp29_ = TRUE;
						while (TRUE) {
							gboolean _tmp31_ = FALSE;
							if (!_tmp29_) {
								gint _tmp30_;
								_tmp30_ = file;
								file = _tmp30_ + 1;
							}
							_tmp29_ = FALSE;
							if (!(file < 8)) {
								break;
							}
							if (_vala_f0 >= 0) {
								_tmp31_ = file != _vala_f0;
							} else {
								_tmp31_ = FALSE;
							}
							if (_tmp31_) {
								continue;
							}
							{
								gint rank = 0;
								rank = 0;
								{
									gboolean _tmp32_ = FALSE;
									_tmp32_ = TRUE;
									while (TRUE) {
										gboolean _tmp34_ = FALSE;
										ChessPiece* piece = NULL;
										ChessPiece* _tmp35_;
										ChessPiece* _tmp36_;
										gboolean _tmp37_ = FALSE;
										gboolean _tmp38_ = FALSE;
										ChessPiece* _tmp39_;
										if (!_tmp32_) {
											gint _tmp33_;
											_tmp33_ = rank;
											rank = _tmp33_ + 1;
										}
										_tmp32_ = FALSE;
										if (!(rank < 8)) {
											break;
										}
										if (_vala_r0 >= 0) {
											_tmp34_ = rank != _vala_r0;
										} else {
											_tmp34_ = FALSE;
										}
										if (_tmp34_) {
											continue;
										}
										_tmp35_ = self->board[chess_state_get_index (self, rank, file)];
										_tmp36_ = _g_object_ref0 (_tmp35_);
										piece = _tmp36_;
										_tmp39_ = piece;
										if (_tmp39_ == NULL) {
											_tmp38_ = TRUE;
										} else {
											ChessPiece* _tmp40_;
											PieceType _tmp41_;
											PieceType _tmp42_;
											_tmp40_ = piece;
											_tmp41_ = _tmp40_->type;
											_tmp42_ = type;
											_tmp38_ = _tmp41_ != _tmp42_;
										}
										if (_tmp38_) {
											_tmp37_ = TRUE;
										} else {
											ChessPiece* _tmp43_;
											ChessPlayer* _tmp44_;
											_tmp43_ = piece;
											_tmp44_ = _tmp43_->player;
											_tmp37_ = _tmp44_ != player;
										}
										if (_tmp37_) {
											_g_object_unref0 (piece);
											continue;
										}
										if (!chess_state_move_with_coords (self, player, rank, file, _vala_r1, _vala_f1, PIECE_TYPE_QUEEN, FALSE, TRUE)) {
											_g_object_unref0 (piece);
											continue;
										}
										if (match_rank >= 0) {
											g_debug ("chess-state.vala:944: Move %s is ambiguous", move);
											result = FALSE;
											_g_object_unref0 (piece);
											if (r0) {
												*r0 = _vala_r0;
											}
											if (f0) {
												*f0 = _vala_f0;
											}
											if (r1) {
												*r1 = _vala_r1;
											}
											if (f1) {
												*f1 = _vala_f1;
											}
											if (promotion_type) {
												*promotion_type = _vala_promotion_type;
											}
											return result;
										}
										match_rank = rank;
										match_file = file;
										_g_object_unref0 (piece);
									}
								}
							}
						}
					}
				}
				if (match_rank < 0) {
					g_debug ("chess-state.vala:955: Move %s has no matches", move);
					result = FALSE;
					if (r0) {
						*r0 = _vala_r0;
					}
					if (f0) {
						*f0 = _vala_f0;
					}
					if (r1) {
						*r1 = _vala_r1;
					}
					if (f1) {
						*f1 = _vala_f1;
					}
					if (promotion_type) {
						*promotion_type = _vala_promotion_type;
					}
					return result;
				}
				_vala_r0 = match_rank;
				_vala_f0 = match_file;
			}
		}
	}
	if (string_get (move, (glong) i) == '+') {
		gint _tmp45_;
		_tmp45_ = i;
		i = _tmp45_ + 1;
	} else {
		if (string_get (move, (glong) i) == '#') {
			gint _tmp46_;
			_tmp46_ = i;
			i = _tmp46_ + 1;
		}
	}
	if (string_get (move, (glong) i) != '\0') {
		g_debug ("chess-state.vala:971: Move %s has unexpected characters", move);
		result = FALSE;
		if (r0) {
			*r0 = _vala_r0;
		}
		if (f0) {
			*f0 = _vala_f0;
		}
		if (r1) {
			*r1 = _vala_r1;
		}
		if (f1) {
			*f1 = _vala_f1;
		}
		if (promotion_type) {
			*promotion_type = _vala_promotion_type;
		}
		return result;
	}
	result = TRUE;
	if (r0) {
		*r0 = _vala_r0;
	}
	if (f0) {
		*f0 = _vala_f0;
	}
	if (r1) {
		*r1 = _vala_r1;
	}
	if (f1) {
		*f1 = _vala_f1;
	}
	if (promotion_type) {
		*promotion_type = _vala_promotion_type;
	}
	return result;
}

ChessPlayer*
chess_state_get_opponent (ChessState* self)
{
	ChessPlayer* result;
	ChessPlayer* _tmp0_ = NULL;
	ChessPlayer* _tmp1_;
	Color _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = self->current_player;
	_tmp2_ = _tmp1_->color;
	if (_tmp2_ == COLOR_WHITE) {
		ChessPlayer* _tmp3_;
		_tmp3_ = self->players[COLOR_BLACK];
		_tmp0_ = _tmp3_;
	} else {
		ChessPlayer* _tmp4_;
		_tmp4_ = self->players[COLOR_WHITE];
		_tmp0_ = _tmp4_;
	}
	result = _tmp0_;
	return result;
}

static void
chess_state_class_init (ChessStateClass * klass,
                        gpointer klass_data)
{
	chess_state_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ChessState_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_chess_state_get_property;
	G_OBJECT_CLASS (klass)->finalize = chess_state_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_STATE_OPPONENT_PROPERTY, chess_state_properties[CHESS_STATE_OPPONENT_PROPERTY] = g_param_spec_object ("opponent", "opponent", "opponent", TYPE_CHESS_PLAYER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
chess_state_instance_init (ChessState * self,
                           gpointer klass)
{
	self->priv = chess_state_get_instance_private (self);
	self->number = 0;
	self->en_passant_index = -1;
	self->last_move = NULL;
}

static void
chess_state_finalize (GObject * obj)
{
	ChessState * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CHESS_STATE, ChessState);
	_vala_array_destroy (self->players, 2, (GDestroyNotify) g_object_unref);
	_g_object_unref0 (self->current_player);
	_vala_array_destroy (self->board, 64, (GDestroyNotify) g_object_unref);
	_g_object_unref0 (self->last_move);
	G_OBJECT_CLASS (chess_state_parent_class)->finalize (obj);
}

GType
chess_state_get_type (void)
{
	static volatile gsize chess_state_type_id__volatile = 0;
	if (g_once_init_enter (&chess_state_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ChessStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) chess_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ChessState), 0, (GInstanceInitFunc) chess_state_instance_init, NULL };
		GType chess_state_type_id;
		chess_state_type_id = g_type_register_static (G_TYPE_OBJECT, "ChessState", &g_define_type_info, 0);
		ChessState_private_offset = g_type_add_instance_private (chess_state_type_id, sizeof (ChessStatePrivate));
		g_once_init_leave (&chess_state_type_id__volatile, chess_state_type_id);
	}
	return chess_state_type_id__volatile;
}

static void
_vala_chess_state_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	ChessState * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_STATE, ChessState);
	switch (property_id) {
		case CHESS_STATE_OPPONENT_PROPERTY:
		g_value_set_object (value, chess_state_get_opponent (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

